const ticketsToDistribute = {
    '0': 9,
    '1': 9,
    '2': 7,
    '3': 7,
    '4': 7,
    '5': 5,
    '6': 5,
    '7': 5,
    '8': 3,
    '9': 3,
    '11': 9,
    '12': 9,
    '13': 9,
    '14': 7,
    '10': 7,
    '15': 5,
    '16': 5,
    '17': 3,
    '18': 3,
    '19': 3,
};
const totalTickets = Object.entries(ticketsToDistribute).reduce((a, [b, c]) => a + c, 0);
console.log({ totalTickets });
const ticketTemplate = {
    MNGO_L: 6666,
    MNGO_M: 420,
    MNGO_S: 69,
    USDC: 4.2,
    SOL_L: 1,
    SOL_M: 0.1,
    SOL_S: 0.01,
    MSOL: 0.1,
    'nft#1': 1,
    'skin_nft#1': 1,
    'skin_nft#2': 1,
    'skin_nft#3': 1,
};
console.log({ ticketTemplate });
const prizePool = {
    MNGO_L: 80_000,
    MNGO_M: 15_000,
    MNGO_S: 5_000,
    USDC: 100,
    SOL_L: 3,
    SOL_M: 1,
    SOL_S: 0.1,
    MSOL: 1,
    'nft#1': 1,
    'skin_nft#1': 20,
    'skin_nft#2': 10,
    'skin_nft#3': 3,
};
console.log({ prizePool });
const prizes = Object.entries(prizePool).flatMap(([mint, amount]) => {
    const numPrizes = Math.floor(amount / ticketTemplate[mint]);
    return Array(numPrizes).fill([mint, ticketTemplate[mint]]);
});
function shuffleArray(array) {
    for (let i = array.length - 1; i > 0; i--) {
        const j = Math.floor(Math.random() * (i + 1));
        [array[i], array[j]] = [array[j], array[i]];
    }
    return array;
}
shuffleArray(prizes);
shuffleArray(prizes);
if (prizes.length < totalTickets) {
    console.error("we're missing prizes. fuck!");
    process.exit(-1);
}
console.log({ prizes, len: prizes.length });
const prizesToDistribute = {};
for (const [wallet, numTickets] of shuffleArray(Object.entries(ticketsToDistribute))) {
    console.log(wallet, numTickets);
    if (!prizesToDistribute[wallet])
        prizesToDistribute[wallet] = [];
    outer: for (let i = 0; i < numTickets; i++) {
        for (let j = 0; j < prizes.length; j++) {
            if (!prizesToDistribute[wallet].includes(prizes[j])) {
                prizesToDistribute[wallet].push(prizes.splice(j, 1)[0]);
                continue outer;
            }
        }
        console.error("we couldn't find a solution. retry!");
        process.exit(-2);
    }
}
console.log('prizesToDistribute', prizesToDistribute);
const remainingPrizePool = prizes.reduce((a, [mint, amount]) => {
    a[mint] = amount + (a[mint] ?? 0);
    return a;
}, {});
console.log({ remainingPrizePool });
console.log('jackpot', Object.entries(prizesToDistribute).find(([wallet, prizes]) => prizes.find(([mint, _amount]) => mint === 'nft#1')));
